# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr

class AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock(BaseModel):
    """
    Refers to the specific block the transaction was mined in.
    """
    height: StrictInt = Field(..., description="Defines the number of blocks in the blockchain preceding this specific block.")
    hash: StrictStr = Field(..., description="Represents the hash of the block's header, i.e. an output that has a fixed length.")
    timestamp: StrictInt = Field(..., description="Defines the exact date/time when this transaction was mined in seconds since Unix Epoch time.")
    __properties = ["height", "hash", "timestamp"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock:
        """Create an instance of AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock:
        """Create an instance of AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock.parse_obj(obj)

        _obj = AddressCoinsTransactionConfirmedEachConfirmationDataItemMinedInBlock.parse_obj({
            "height": obj.get("height"),
            "hash": obj.get("hash"),
            "timestamp": obj.get("timestamp")
        })
        return _obj

