# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from cryptoapis.models.address_tokens_transaction_confirmed_bep20 import AddressTokensTransactionConfirmedBep20
from cryptoapis.models.address_tokens_transaction_confirmed_erc20 import AddressTokensTransactionConfirmedErc20
from cryptoapis.models.address_tokens_transaction_confirmed_erc721 import AddressTokensTransactionConfirmedErc721
from cryptoapis.models.address_tokens_transaction_confirmed_omni import AddressTokensTransactionConfirmedOmni
from cryptoapis.models.address_tokens_transaction_confirmed_trc20 import AddressTokensTransactionConfirmedTrc20
from cryptoapis.models.address_tokens_transaction_confirmed_trc721 import AddressTokensTransactionConfirmedTrc721
from typing import Any, List
from pydantic import StrictStr, Field

ADDRESSTOKENSTRANSACTIONCONFIRMEDTOKEN_ONE_OF_SCHEMAS = ["AddressTokensTransactionConfirmedBep20", "AddressTokensTransactionConfirmedErc20", "AddressTokensTransactionConfirmedErc721", "AddressTokensTransactionConfirmedOmni", "AddressTokensTransactionConfirmedTrc20", "AddressTokensTransactionConfirmedTrc721"]

class AddressTokensTransactionConfirmedToken(BaseModel):
    """
    AddressTokensTransactionConfirmedToken
    """
    # data type: AddressTokensTransactionConfirmedErc20
    oneof_schema_1_validator: Optional[AddressTokensTransactionConfirmedErc20] = None
    # data type: AddressTokensTransactionConfirmedErc721
    oneof_schema_2_validator: Optional[AddressTokensTransactionConfirmedErc721] = None
    # data type: AddressTokensTransactionConfirmedOmni
    oneof_schema_3_validator: Optional[AddressTokensTransactionConfirmedOmni] = None
    # data type: AddressTokensTransactionConfirmedBep20
    oneof_schema_4_validator: Optional[AddressTokensTransactionConfirmedBep20] = None
    # data type: AddressTokensTransactionConfirmedTrc20
    oneof_schema_5_validator: Optional[AddressTokensTransactionConfirmedTrc20] = None
    # data type: AddressTokensTransactionConfirmedTrc721
    oneof_schema_6_validator: Optional[AddressTokensTransactionConfirmedTrc721] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(ADDRESSTOKENSTRANSACTIONCONFIRMEDTOKEN_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = AddressTokensTransactionConfirmedToken.construct()
        error_messages = []
        match = 0
        # validate data type: AddressTokensTransactionConfirmedErc20
        if not isinstance(v, AddressTokensTransactionConfirmedErc20):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedErc20`")
        else:
            match += 1
        # validate data type: AddressTokensTransactionConfirmedErc721
        if not isinstance(v, AddressTokensTransactionConfirmedErc721):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedErc721`")
        else:
            match += 1
        # validate data type: AddressTokensTransactionConfirmedOmni
        if not isinstance(v, AddressTokensTransactionConfirmedOmni):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedOmni`")
        else:
            match += 1
        # validate data type: AddressTokensTransactionConfirmedBep20
        if not isinstance(v, AddressTokensTransactionConfirmedBep20):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedBep20`")
        else:
            match += 1
        # validate data type: AddressTokensTransactionConfirmedTrc20
        if not isinstance(v, AddressTokensTransactionConfirmedTrc20):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedTrc20`")
        else:
            match += 1
        # validate data type: AddressTokensTransactionConfirmedTrc721
        if not isinstance(v, AddressTokensTransactionConfirmedTrc721):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressTokensTransactionConfirmedTrc721`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in AddressTokensTransactionConfirmedToken with oneOf schemas: AddressTokensTransactionConfirmedBep20, AddressTokensTransactionConfirmedErc20, AddressTokensTransactionConfirmedErc721, AddressTokensTransactionConfirmedOmni, AddressTokensTransactionConfirmedTrc20, AddressTokensTransactionConfirmedTrc721. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in AddressTokensTransactionConfirmedToken with oneOf schemas: AddressTokensTransactionConfirmedBep20, AddressTokensTransactionConfirmedErc20, AddressTokensTransactionConfirmedErc721, AddressTokensTransactionConfirmedOmni, AddressTokensTransactionConfirmedTrc20, AddressTokensTransactionConfirmedTrc721. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> AddressTokensTransactionConfirmedToken:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> AddressTokensTransactionConfirmedToken:
        """Returns the object represented by the json string"""
        instance = AddressTokensTransactionConfirmedToken.construct()
        error_messages = []
        match = 0

        # deserialize data into AddressTokensTransactionConfirmedErc20
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedErc20.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressTokensTransactionConfirmedErc721
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedErc721.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressTokensTransactionConfirmedOmni
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedOmni.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressTokensTransactionConfirmedBep20
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedBep20.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressTokensTransactionConfirmedTrc20
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedTrc20.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressTokensTransactionConfirmedTrc721
        try:
            instance.actual_instance = AddressTokensTransactionConfirmedTrc721.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into AddressTokensTransactionConfirmedToken with oneOf schemas: AddressTokensTransactionConfirmedBep20, AddressTokensTransactionConfirmedErc20, AddressTokensTransactionConfirmedErc721, AddressTokensTransactionConfirmedOmni, AddressTokensTransactionConfirmedTrc20, AddressTokensTransactionConfirmedTrc721. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AddressTokensTransactionConfirmedToken with oneOf schemas: AddressTokensTransactionConfirmedBep20, AddressTokensTransactionConfirmedErc20, AddressTokensTransactionConfirmedErc721, AddressTokensTransactionConfirmedOmni, AddressTokensTransactionConfirmedTrc20, AddressTokensTransactionConfirmedTrc721. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

