# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class AddressTokensTransactionConfirmedTrc20(BaseModel):
    """
    TRC-20
    """
    name: StrictStr = Field(...)
    symbol: StrictStr = Field(...)
    decimals: Optional[StrictStr] = None
    amount: StrictStr = Field(...)
    contract_address: StrictStr = Field(..., alias="contractAddress")
    __properties = ["name", "symbol", "decimals", "amount", "contractAddress"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AddressTokensTransactionConfirmedTrc20:
        """Create an instance of AddressTokensTransactionConfirmedTrc20 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AddressTokensTransactionConfirmedTrc20:
        """Create an instance of AddressTokensTransactionConfirmedTrc20 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AddressTokensTransactionConfirmedTrc20.parse_obj(obj)

        _obj = AddressTokensTransactionConfirmedTrc20.parse_obj({
            "name": obj.get("name"),
            "symbol": obj.get("symbol"),
            "decimals": obj.get("decimals"),
            "amount": obj.get("amount"),
            "contract_address": obj.get("contractAddress")
        })
        return _obj

