# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class CreateCoinsTransactionRequestFromAddressRIRecipientsInner(BaseModel):
    """
    CreateCoinsTransactionRequestFromAddressRIRecipientsInner
    """
    address: StrictStr = Field(..., description="Defines the destination address.")
    address_tag: Optional[StrictInt] = Field(None, alias="addressTag", description="Defines a specific Tag that is an additional XRP address feature. It helps identify a transaction recipient beyond a wallet address. The tag that was encoded into the x-Address along with the Source Classic Address.")
    amount: StrictStr = Field(..., description="Defines the amount sent to the destination address.")
    classic_address: Optional[StrictStr] = Field(None, alias="classicAddress", description="Represents the public address, which is a compressed and shortened form of a public key. The classic address is shown when the source address is an x-Address.")
    __properties = ["address", "addressTag", "amount", "classicAddress"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateCoinsTransactionRequestFromAddressRIRecipientsInner:
        """Create an instance of CreateCoinsTransactionRequestFromAddressRIRecipientsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateCoinsTransactionRequestFromAddressRIRecipientsInner:
        """Create an instance of CreateCoinsTransactionRequestFromAddressRIRecipientsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateCoinsTransactionRequestFromAddressRIRecipientsInner.parse_obj(obj)

        _obj = CreateCoinsTransactionRequestFromAddressRIRecipientsInner.parse_obj({
            "address": obj.get("address"),
            "address_tag": obj.get("addressTag"),
            "amount": obj.get("amount"),
            "classic_address": obj.get("classicAddress")
        })
        return _obj

