# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from cryptoapis.models.create_fungible_token_transaction_request_from_address_without_fee_priority_ri_recipient_inner import CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIRecipientInner
from cryptoapis.models.create_fungible_token_transaction_request_from_address_without_fee_priority_ris import CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIS
from cryptoapis.models.create_single_transaction_request_from_address_without_fee_priority_ri_sender import CreateSingleTransactionRequestFromAddressWithoutFeePriorityRISender

class CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI(BaseModel):
    """
    CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI
    """
    callback_secret_key: Optional[StrictStr] = Field(None, alias="callbackSecretKey", description="Represents the Secret Key value provided by the customer. This field is used for security purposes during the callback notification, in order to prove the sender of the callback as Crypto APIs. For more information please see our [Documentation](https://developers.cryptoapis.io/technical-documentation/general-information/callbacks#callback-security).")
    callback_url: Optional[StrictStr] = Field(None, alias="callbackUrl", description="Represents the URL that is set by the customer where the callback will be received at. The callback notification will be received only if and when the event occurs. `We support ONLY httpS type of protocol`.")
    note: Optional[StrictStr] = Field(None, description="Represents an optional note to add a free text in, explaining or providing additional detail on the transaction request.")
    recipient: conlist(CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIRecipientInner) = Field(..., description="Defines the destination for the transaction, i.e. the recipient(s).")
    sender: CreateSingleTransactionRequestFromAddressWithoutFeePriorityRISender = Field(...)
    token_type_specific_data: CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIS = Field(..., alias="tokenTypeSpecificData")
    transaction_request_id: StrictStr = Field(..., alias="transactionRequestId", description="Represents a unique identifier of the transaction request (the request sent to make a transaction), which helps in identifying which callback and which `referenceId` concern that specific transaction request.")
    __properties = ["callbackSecretKey", "callbackUrl", "note", "recipient", "sender", "tokenTypeSpecificData", "transactionRequestId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI:
        """Create an instance of CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in recipient (list)
        _items = []
        if self.recipient:
            for _item in self.recipient:
                if _item:
                    _items.append(_item.to_dict())
            _dict['recipient'] = _items
        # override the default output from pydantic by calling `to_dict()` of sender
        if self.sender:
            _dict['sender'] = self.sender.to_dict()
        # override the default output from pydantic by calling `to_dict()` of token_type_specific_data
        if self.token_type_specific_data:
            _dict['tokenTypeSpecificData'] = self.token_type_specific_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI:
        """Create an instance of CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI.parse_obj(obj)

        _obj = CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRI.parse_obj({
            "callback_secret_key": obj.get("callbackSecretKey"),
            "callback_url": obj.get("callbackUrl"),
            "note": obj.get("note"),
            "recipient": [CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIRecipientInner.from_dict(_item) for _item in obj.get("recipient")] if obj.get("recipient") is not None else None,
            "sender": CreateSingleTransactionRequestFromAddressWithoutFeePriorityRISender.from_dict(obj.get("sender")) if obj.get("sender") is not None else None,
            "token_type_specific_data": CreateFungibleTokenTransactionRequestFromAddressWithoutFeePriorityRIS.from_dict(obj.get("tokenTypeSpecificData")) if obj.get("tokenTypeSpecificData") is not None else None,
            "transaction_request_id": obj.get("transactionRequestId")
        })
        return _obj

