# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr

class GenerateDepositAddressRI(BaseModel):
    """
    GenerateDepositAddressRI
    """
    address: StrictStr = Field(..., description="Specifies the specific address's unique string value.")
    created_timestamp: StrictInt = Field(..., alias="createdTimestamp", description="Defines the specific UNIX time when the deposit address was created.")
    label: StrictStr = Field(..., description="Represents a custom tag that customers can set up for their Wallets and addresses. E.g. custom label named \"Special addresses\".")
    __properties = ["address", "createdTimestamp", "label"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GenerateDepositAddressRI:
        """Create an instance of GenerateDepositAddressRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GenerateDepositAddressRI:
        """Create an instance of GenerateDepositAddressRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GenerateDepositAddressRI.parse_obj(obj)

        _obj = GenerateDepositAddressRI.parse_obj({
            "address": obj.get("address"),
            "created_timestamp": obj.get("createdTimestamp"),
            "label": obj.get("label")
        })
        return _obj

