# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field
from cryptoapis.models.get_eip1559_fee_recommendations_ri_base_fee_per_gas import GetEIP1559FeeRecommendationsRIBaseFeePerGas
from cryptoapis.models.get_eip1559_fee_recommendations_ri_max_fee_per_gas import GetEIP1559FeeRecommendationsRIMaxFeePerGas
from cryptoapis.models.get_eip1559_fee_recommendations_ri_max_priority_fee_per_gas import GetEIP1559FeeRecommendationsRIMaxPriorityFeePerGas

class GetEIP1559FeeRecommendationsRI(BaseModel):
    """
    GetEIP1559FeeRecommendationsRI
    """
    base_fee_per_gas: GetEIP1559FeeRecommendationsRIBaseFeePerGas = Field(..., alias="baseFeePerGas")
    max_fee_per_gas: GetEIP1559FeeRecommendationsRIMaxFeePerGas = Field(..., alias="maxFeePerGas")
    max_priority_fee_per_gas: GetEIP1559FeeRecommendationsRIMaxPriorityFeePerGas = Field(..., alias="maxPriorityFeePerGas")
    __properties = ["baseFeePerGas", "maxFeePerGas", "maxPriorityFeePerGas"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetEIP1559FeeRecommendationsRI:
        """Create an instance of GetEIP1559FeeRecommendationsRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of base_fee_per_gas
        if self.base_fee_per_gas:
            _dict['baseFeePerGas'] = self.base_fee_per_gas.to_dict()
        # override the default output from pydantic by calling `to_dict()` of max_fee_per_gas
        if self.max_fee_per_gas:
            _dict['maxFeePerGas'] = self.max_fee_per_gas.to_dict()
        # override the default output from pydantic by calling `to_dict()` of max_priority_fee_per_gas
        if self.max_priority_fee_per_gas:
            _dict['maxPriorityFeePerGas'] = self.max_priority_fee_per_gas.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetEIP1559FeeRecommendationsRI:
        """Create an instance of GetEIP1559FeeRecommendationsRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetEIP1559FeeRecommendationsRI.parse_obj(obj)

        _obj = GetEIP1559FeeRecommendationsRI.parse_obj({
            "base_fee_per_gas": GetEIP1559FeeRecommendationsRIBaseFeePerGas.from_dict(obj.get("baseFeePerGas")) if obj.get("baseFeePerGas") is not None else None,
            "max_fee_per_gas": GetEIP1559FeeRecommendationsRIMaxFeePerGas.from_dict(obj.get("maxFeePerGas")) if obj.get("maxFeePerGas") is not None else None,
            "max_priority_fee_per_gas": GetEIP1559FeeRecommendationsRIMaxPriorityFeePerGas.from_dict(obj.get("maxPriorityFeePerGas")) if obj.get("maxPriorityFeePerGas") is not None else None
        })
        return _obj

