# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr

class GetExchangeRateByAssetsIDsRI(BaseModel):
    """
    GetExchangeRateByAssetsIDsRI
    """
    calculation_timestamp: StrictInt = Field(..., alias="calculationTimestamp", description="Defines the time of the market data used to calculate the exchange rate in UNIX Timestamp. Oldest possible timestamp is 30 days.")
    from_asset_id: StrictStr = Field(..., alias="fromAssetId", description="Defines the base asset Reference ID to get a rate for.")
    from_asset_symbol: StrictStr = Field(..., alias="fromAssetSymbol", description="Defines the base asset symbol to get a rate for.")
    rate: StrictStr = Field(..., description="Defines the exchange rate between assets calculated by weighted average of the last trades in every exchange for the last 24 hours by giving more weight to exchanges with higher volume.")
    to_asset_id: StrictStr = Field(..., alias="toAssetId", description="Defines the relation asset Reference ID in which the base asset rate will be displayed.")
    to_asset_symbol: StrictStr = Field(..., alias="toAssetSymbol", description="Defines the relation asset symbol in which the base asset rate will be displayed.")
    __properties = ["calculationTimestamp", "fromAssetId", "fromAssetSymbol", "rate", "toAssetId", "toAssetSymbol"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetExchangeRateByAssetsIDsRI:
        """Create an instance of GetExchangeRateByAssetsIDsRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetExchangeRateByAssetsIDsRI:
        """Create an instance of GetExchangeRateByAssetsIDsRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetExchangeRateByAssetsIDsRI.parse_obj(obj)

        _obj = GetExchangeRateByAssetsIDsRI.parse_obj({
            "calculation_timestamp": obj.get("calculationTimestamp"),
            "from_asset_id": obj.get("fromAssetId"),
            "from_asset_symbol": obj.get("fromAssetSymbol"),
            "rate": obj.get("rate"),
            "to_asset_id": obj.get("toAssetId"),
            "to_asset_symbol": obj.get("toAssetSymbol")
        })
        return _obj

