# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class ListConfirmedTransactionsByAddressRIBST2(BaseModel):
    """
    Tezos
    """
    addresses: conlist(StrictStr) = Field(...)
    counter: StrictInt = Field(..., description="Representation of the counter value")
    gas_limit: StrictStr = Field(..., alias="gasLimit", description="Represents the amount of gas used by this specific transaction alone.")
    gas_used: StrictStr = Field(..., alias="gasUsed", description="Represents the exact unit of gas that was used for the transaction.")
    has_internal_transactions: StrictBool = Field(..., alias="hasInternalTransactions", description="Represents the presence of internal transactions")
    is_confirmed: StrictBool = Field(..., alias="isConfirmed", description="Representation of the confirmation status of the transfer")
    nonce: Optional[StrictInt] = Field(None, description="Defines the nonce")
    token_transfers_count: StrictInt = Field(..., alias="tokenTransfersCount", description="Representation of the  token transfers count")
    transaction_status: StrictStr = Field(..., alias="transactionStatus", description="Defines the transaction status")
    __properties = ["addresses", "counter", "gasLimit", "gasUsed", "hasInternalTransactions", "isConfirmed", "nonce", "tokenTransfersCount", "transactionStatus"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListConfirmedTransactionsByAddressRIBST2:
        """Create an instance of ListConfirmedTransactionsByAddressRIBST2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListConfirmedTransactionsByAddressRIBST2:
        """Create an instance of ListConfirmedTransactionsByAddressRIBST2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListConfirmedTransactionsByAddressRIBST2.parse_obj(obj)

        _obj = ListConfirmedTransactionsByAddressRIBST2.parse_obj({
            "addresses": obj.get("addresses"),
            "counter": obj.get("counter"),
            "gas_limit": obj.get("gasLimit"),
            "gas_used": obj.get("gasUsed"),
            "has_internal_transactions": obj.get("hasInternalTransactions"),
            "is_confirmed": obj.get("isConfirmed"),
            "nonce": obj.get("nonce"),
            "token_transfers_count": obj.get("tokenTransfersCount"),
            "transaction_status": obj.get("transactionStatus")
        })
        return _obj

