# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from cryptoapis.models.list_deposit_addresses_ri_confirmed_balance import ListDepositAddressesRIConfirmedBalance
from cryptoapis.models.list_deposit_addresses_ri_fungible_tokens_inner import ListDepositAddressesRIFungibleTokensInner
from cryptoapis.models.list_deposit_addresses_ri_non_fungible_tokens_inner import ListDepositAddressesRINonFungibleTokensInner

class ListDepositAddressesRI(BaseModel):
    """
    ListDepositAddressesRI
    """
    address: StrictStr = Field(..., description="Specifies the specific address's unique string value.")
    confirmed_balance: ListDepositAddressesRIConfirmedBalance = Field(..., alias="confirmedBalance")
    created_timestamp: StrictInt = Field(..., alias="createdTimestamp", description="Defines the specific UNIX time when the deposit address was created.")
    fungible_tokens: conlist(ListDepositAddressesRIFungibleTokensInner) = Field(..., alias="fungibleTokens", description="Represents fungible tokens'es detailed information")
    index: StrictStr = Field(..., description="Represents the index of the address in the wallet.")
    label: StrictStr = Field(..., description="Represents a custom tag that customers can set up for their Wallets and addresses. E.g. custom label named \"Special addresses\".")
    non_fungible_tokens: conlist(ListDepositAddressesRINonFungibleTokensInner) = Field(..., alias="nonFungibleTokens", description="Represents non-fungible tokens'es detailed information.")
    __properties = ["address", "confirmedBalance", "createdTimestamp", "fungibleTokens", "index", "label", "nonFungibleTokens"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListDepositAddressesRI:
        """Create an instance of ListDepositAddressesRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of confirmed_balance
        if self.confirmed_balance:
            _dict['confirmedBalance'] = self.confirmed_balance.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in fungible_tokens (list)
        _items = []
        if self.fungible_tokens:
            for _item in self.fungible_tokens:
                if _item:
                    _items.append(_item.to_dict())
            _dict['fungibleTokens'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in non_fungible_tokens (list)
        _items = []
        if self.non_fungible_tokens:
            for _item in self.non_fungible_tokens:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nonFungibleTokens'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListDepositAddressesRI:
        """Create an instance of ListDepositAddressesRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListDepositAddressesRI.parse_obj(obj)

        _obj = ListDepositAddressesRI.parse_obj({
            "address": obj.get("address"),
            "confirmed_balance": ListDepositAddressesRIConfirmedBalance.from_dict(obj.get("confirmedBalance")) if obj.get("confirmedBalance") is not None else None,
            "created_timestamp": obj.get("createdTimestamp"),
            "fungible_tokens": [ListDepositAddressesRIFungibleTokensInner.from_dict(_item) for _item in obj.get("fungibleTokens")] if obj.get("fungibleTokens") is not None else None,
            "index": obj.get("index"),
            "label": obj.get("label"),
            "non_fungible_tokens": [ListDepositAddressesRINonFungibleTokensInner.from_dict(_item) for _item in obj.get("nonFungibleTokens")] if obj.get("nonFungibleTokens") is not None else None
        })
        return _obj

