# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr
from cryptoapis.models.list_latest_mined_blocks_ribs import ListLatestMinedBlocksRIBS

class ListLatestMinedBlocksRI(BaseModel):
    """
    ListLatestMinedBlocksRI
    """
    hash: StrictStr = Field(..., description="Represents the same as transactionId for account-based protocols like Ethereum, while it could be different in UTXO-based protocols like Bitcoin. E.g., in UTXO-based protocols hash is different from transactionId for SegWit transactions.")
    height: StrictInt = Field(..., description="Represents the hight of the block where this transaction was mined/confirmed for first time. The height is defined as the number of blocks in the blockchain preceding this specific block.")
    previous_block_hash: StrictStr = Field(..., alias="previousBlockHash", description="Represents the hash of the previous block, also known as the parent block.")
    timestamp: StrictInt = Field(..., description="Defines the exact date/time when this block was mined in Unix Timestamp.")
    transactions_count: StrictInt = Field(..., alias="transactionsCount", description="Represents the total number of all transactions as part of this block.")
    blockchain_specific: ListLatestMinedBlocksRIBS = Field(..., alias="blockchainSpecific")
    __properties = ["hash", "height", "previousBlockHash", "timestamp", "transactionsCount", "blockchainSpecific"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListLatestMinedBlocksRI:
        """Create an instance of ListLatestMinedBlocksRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of blockchain_specific
        if self.blockchain_specific:
            _dict['blockchainSpecific'] = self.blockchain_specific.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListLatestMinedBlocksRI:
        """Create an instance of ListLatestMinedBlocksRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListLatestMinedBlocksRI.parse_obj(obj)

        _obj = ListLatestMinedBlocksRI.parse_obj({
            "hash": obj.get("hash"),
            "height": obj.get("height"),
            "previous_block_hash": obj.get("previousBlockHash"),
            "timestamp": obj.get("timestamp"),
            "transactions_count": obj.get("transactionsCount"),
            "blockchain_specific": ListLatestMinedBlocksRIBS.from_dict(obj.get("blockchainSpecific")) if obj.get("blockchainSpecific") is not None else None
        })
        return _obj

