# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class ListTokensByAddressRI(BaseModel):
    """
    ListTokensByAddressRI
    """
    confirmed_balance: StrictStr = Field(..., alias="confirmedBalance", description="Defines the token balance that has been confirmed.")
    contract_address: StrictStr = Field(..., alias="contractAddress", description="Represents the contract address of the token, which controls its logic. It is not the address that holds the tokens.")
    name: StrictStr = Field(..., description="Defines the token's name as a string.")
    symbol: StrictStr = Field(..., description="Defines the token symbol by which the token contract is known. It is usually 3-4 characters in length.")
    type: StrictStr = Field(..., description="Defines the specific token type.")
    __properties = ["confirmedBalance", "contractAddress", "name", "symbol", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListTokensByAddressRI:
        """Create an instance of ListTokensByAddressRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListTokensByAddressRI:
        """Create an instance of ListTokensByAddressRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListTokensByAddressRI.parse_obj(obj)

        _obj = ListTokensByAddressRI.parse_obj({
            "confirmed_balance": obj.get("confirmedBalance"),
            "contract_address": obj.get("contractAddress"),
            "name": obj.get("name"),
            "symbol": obj.get("symbol"),
            "type": obj.get("type")
        })
        return _obj

