# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class ListTransactionsByBlockHeightRIBSZVShieldedOutputInner(BaseModel):
    """
    ListTransactionsByBlockHeightRIBSZVShieldedOutputInner
    """
    cmu: StrictStr = Field(..., description="Represents the 𝑢-coordinate of the note commitment for the output note.")
    cv: StrictStr = Field(..., description="Defines a value commitment to the value of the input note.")
    enc_cipher_text: StrictStr = Field(..., alias="encCipherText", description="Represents a ciphertext component for the encrypted output note.")
    ephemeral_key: StrictStr = Field(..., alias="ephemeralKey", description="Represents an encoding of an ephemeral Jubjub public key.")
    out_cipher_text: StrictStr = Field(..., alias="outCipherText", description="Represents a ciphertext component that allows the holder of the outgoing cipher key to recover the diversified transmission key pkd and ephemeral private key esk, hence the entire note plaintext.")
    proof: StrictStr = Field(..., description="Represents the proof")
    __properties = ["cmu", "cv", "encCipherText", "ephemeralKey", "outCipherText", "proof"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListTransactionsByBlockHeightRIBSZVShieldedOutputInner:
        """Create an instance of ListTransactionsByBlockHeightRIBSZVShieldedOutputInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListTransactionsByBlockHeightRIBSZVShieldedOutputInner:
        """Create an instance of ListTransactionsByBlockHeightRIBSZVShieldedOutputInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListTransactionsByBlockHeightRIBSZVShieldedOutputInner.parse_obj(obj)

        _obj = ListTransactionsByBlockHeightRIBSZVShieldedOutputInner.parse_obj({
            "cmu": obj.get("cmu"),
            "cv": obj.get("cv"),
            "enc_cipher_text": obj.get("encCipherText"),
            "ephemeral_key": obj.get("ephemeralKey"),
            "out_cipher_text": obj.get("outCipherText"),
            "proof": obj.get("proof")
        })
        return _obj

