# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr
from cryptoapis.models.list_unconfirmed_transactions_by_address_ribsec_fee import ListUnconfirmedTransactionsByAddressRIBSECFee
from cryptoapis.models.list_unconfirmed_transactions_by_address_ribsec_gas_price import ListUnconfirmedTransactionsByAddressRIBSECGasPrice

class ListUnconfirmedTransactionsByAddressRIBSEC(BaseModel):
    """
    Ethereum Classic
    """
    fee: ListUnconfirmedTransactionsByAddressRIBSECFee = Field(...)
    gas_limit: StrictStr = Field(..., alias="gasLimit", description="Represents the amount of gas used by this specific transaction alone.")
    gas_price: ListUnconfirmedTransactionsByAddressRIBSECGasPrice = Field(..., alias="gasPrice")
    nonce: StrictInt = Field(..., description="Represents the sequential running number for an address, starting from 0 for the first transaction. E.g., if the nonce of a transaction is 10, it would be the 11th transaction sent from the sender's address.")
    transaction_status: StrictStr = Field(..., alias="transactionStatus", description="String representation of the transaction status")
    __properties = ["fee", "gasLimit", "gasPrice", "nonce", "transactionStatus"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListUnconfirmedTransactionsByAddressRIBSEC:
        """Create an instance of ListUnconfirmedTransactionsByAddressRIBSEC from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of fee
        if self.fee:
            _dict['fee'] = self.fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gas_price
        if self.gas_price:
            _dict['gasPrice'] = self.gas_price.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListUnconfirmedTransactionsByAddressRIBSEC:
        """Create an instance of ListUnconfirmedTransactionsByAddressRIBSEC from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListUnconfirmedTransactionsByAddressRIBSEC.parse_obj(obj)

        _obj = ListUnconfirmedTransactionsByAddressRIBSEC.parse_obj({
            "fee": ListUnconfirmedTransactionsByAddressRIBSECFee.from_dict(obj.get("fee")) if obj.get("fee") is not None else None,
            "gas_limit": obj.get("gasLimit"),
            "gas_price": ListUnconfirmedTransactionsByAddressRIBSECGasPrice.from_dict(obj.get("gasPrice")) if obj.get("gasPrice") is not None else None,
            "nonce": obj.get("nonce"),
            "transaction_status": obj.get("transactionStatus")
        })
        return _obj

