# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class ListWalletTransactionsRIInternalTransactionsInner(BaseModel):
    """
    ListWalletTransactionsRIInternalTransactionsInner
    """
    amount: StrictStr = Field(..., description="Defines the specific amount of the transaction.")
    converted_amount: StrictStr = Field(..., alias="convertedAmount", description="Represents the converted amount.")
    exchange_rate_unit: StrictStr = Field(..., alias="exchangeRateUnit", description="Defines the base asset symbol to get a rate for.")
    operation_id: StrictStr = Field(..., alias="operationId", description="Represents the unique internal transaction ID in regards to the parent transaction (type trace address).")
    recipient: StrictStr = Field(..., description="Represents the recipient address with the respective amount.")
    sender: StrictStr = Field(..., description="Represents the sender address with the respective amount.")
    symbol: StrictStr = Field(..., description="Represents the unique unit symbol.")
    __properties = ["amount", "convertedAmount", "exchangeRateUnit", "operationId", "recipient", "sender", "symbol"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListWalletTransactionsRIInternalTransactionsInner:
        """Create an instance of ListWalletTransactionsRIInternalTransactionsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListWalletTransactionsRIInternalTransactionsInner:
        """Create an instance of ListWalletTransactionsRIInternalTransactionsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListWalletTransactionsRIInternalTransactionsInner.parse_obj(obj)

        _obj = ListWalletTransactionsRIInternalTransactionsInner.parse_obj({
            "amount": obj.get("amount"),
            "converted_amount": obj.get("convertedAmount"),
            "exchange_rate_unit": obj.get("exchangeRateUnit"),
            "operation_id": obj.get("operationId"),
            "recipient": obj.get("recipient"),
            "sender": obj.get("sender"),
            "symbol": obj.get("symbol")
        })
        return _obj

