# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_fee import ListXRPRippleTransactionsByBlockHashRIFee
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_offer import ListXRPRippleTransactionsByBlockHashRIOffer
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_receive import ListXRPRippleTransactionsByBlockHashRIReceive
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_recipients_inner import ListXRPRippleTransactionsByBlockHashRIRecipientsInner
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_senders_inner import ListXRPRippleTransactionsByBlockHashRISendersInner
from cryptoapis.models.list_xrp_ripple_transactions_by_block_hash_ri_value import ListXRPRippleTransactionsByBlockHashRIValue

class ListXRPRippleTransactionsByBlockHashRI(BaseModel):
    """
    ListXRPRippleTransactionsByBlockHashRI
    """
    additional_data: Optional[StrictStr] = Field(None, alias="additionalData", description="Represents any additional data that may be needed.")
    destination_tag: Optional[StrictInt] = Field(None, alias="destinationTag")
    index: StrictInt = Field(..., description="Represents the index position of the transaction in the specific block.")
    mined_in_block_height: StrictInt = Field(..., alias="minedInBlockHeight", description="Represents the hight of the block where this transaction was mined/confirmed for first time. The height is defined as the number of blocks in the blockchain preceding this specific block.")
    offer: ListXRPRippleTransactionsByBlockHashRIOffer = Field(...)
    recipients: conlist(ListXRPRippleTransactionsByBlockHashRIRecipientsInner) = Field(..., description="Represents an object of addresses that receive the transactions.")
    senders: conlist(ListXRPRippleTransactionsByBlockHashRISendersInner) = Field(..., description="Represents an object of addresses that provide the funds.")
    sequence: StrictInt = Field(..., description="Defines the transaction input's sequence as an integer, which is is used when transactions are replaced with newer versions before LockTime.")
    status: StrictStr = Field(..., description="Defines the status of the transaction.")
    timestamp: StrictInt = Field(..., description="Defines the exact date/time in Unix Timestamp when this transaction was mined, confirmed or first seen in Mempool, if it is unconfirmed.")
    transaction_hash: StrictStr = Field(..., alias="transactionHash", description="Represents the same as `transactionId` for account-based protocols like Ethereum, while it could be different in UTXO-based protocols like Bitcoin. E.g., in UTXO-based protocols `hash` is different from `transactionId` for SegWit transactions.")
    type: StrictStr = Field(..., description="Defines the type of the transaction.")
    fee: ListXRPRippleTransactionsByBlockHashRIFee = Field(...)
    receive: ListXRPRippleTransactionsByBlockHashRIReceive = Field(...)
    value: ListXRPRippleTransactionsByBlockHashRIValue = Field(...)
    __properties = ["additionalData", "destinationTag", "index", "minedInBlockHeight", "offer", "recipients", "senders", "sequence", "status", "timestamp", "transactionHash", "type", "fee", "receive", "value"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListXRPRippleTransactionsByBlockHashRI:
        """Create an instance of ListXRPRippleTransactionsByBlockHashRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of offer
        if self.offer:
            _dict['offer'] = self.offer.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in recipients (list)
        _items = []
        if self.recipients:
            for _item in self.recipients:
                if _item:
                    _items.append(_item.to_dict())
            _dict['recipients'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in senders (list)
        _items = []
        if self.senders:
            for _item in self.senders:
                if _item:
                    _items.append(_item.to_dict())
            _dict['senders'] = _items
        # override the default output from pydantic by calling `to_dict()` of fee
        if self.fee:
            _dict['fee'] = self.fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of receive
        if self.receive:
            _dict['receive'] = self.receive.to_dict()
        # override the default output from pydantic by calling `to_dict()` of value
        if self.value:
            _dict['value'] = self.value.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListXRPRippleTransactionsByBlockHashRI:
        """Create an instance of ListXRPRippleTransactionsByBlockHashRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListXRPRippleTransactionsByBlockHashRI.parse_obj(obj)

        _obj = ListXRPRippleTransactionsByBlockHashRI.parse_obj({
            "additional_data": obj.get("additionalData"),
            "destination_tag": obj.get("destinationTag"),
            "index": obj.get("index"),
            "mined_in_block_height": obj.get("minedInBlockHeight"),
            "offer": ListXRPRippleTransactionsByBlockHashRIOffer.from_dict(obj.get("offer")) if obj.get("offer") is not None else None,
            "recipients": [ListXRPRippleTransactionsByBlockHashRIRecipientsInner.from_dict(_item) for _item in obj.get("recipients")] if obj.get("recipients") is not None else None,
            "senders": [ListXRPRippleTransactionsByBlockHashRISendersInner.from_dict(_item) for _item in obj.get("senders")] if obj.get("senders") is not None else None,
            "sequence": obj.get("sequence"),
            "status": obj.get("status"),
            "timestamp": obj.get("timestamp"),
            "transaction_hash": obj.get("transactionHash"),
            "type": obj.get("type"),
            "fee": ListXRPRippleTransactionsByBlockHashRIFee.from_dict(obj.get("fee")) if obj.get("fee") is not None else None,
            "receive": ListXRPRippleTransactionsByBlockHashRIReceive.from_dict(obj.get("receive")) if obj.get("receive") is not None else None,
            "value": ListXRPRippleTransactionsByBlockHashRIValue.from_dict(obj.get("value")) if obj.get("value") is not None else None
        })
        return _obj

