# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from cryptoapis.models.prepare_a_fungible_token_transfer_from_address_ribsbsc import PrepareAFungibleTokenTransferFromAddressRIBSBSC
from cryptoapis.models.prepare_a_fungible_token_transfer_from_address_ribse import PrepareAFungibleTokenTransferFromAddressRIBSE
from cryptoapis.models.prepare_a_fungible_token_transfer_from_address_ribsec import PrepareAFungibleTokenTransferFromAddressRIBSEC
from typing import Any, List
from pydantic import StrictStr, Field

PREPAREAFUNGIBLETOKENTRANSFERFROMADDRESSRIBS_ONE_OF_SCHEMAS = ["PrepareAFungibleTokenTransferFromAddressRIBSBSC", "PrepareAFungibleTokenTransferFromAddressRIBSE", "PrepareAFungibleTokenTransferFromAddressRIBSEC"]

class PrepareAFungibleTokenTransferFromAddressRIBS(BaseModel):
    """
    PrepareAFungibleTokenTransferFromAddressRIBS
    """
    # data type: PrepareAFungibleTokenTransferFromAddressRIBSE
    oneof_schema_1_validator: Optional[PrepareAFungibleTokenTransferFromAddressRIBSE] = None
    # data type: PrepareAFungibleTokenTransferFromAddressRIBSEC
    oneof_schema_2_validator: Optional[PrepareAFungibleTokenTransferFromAddressRIBSEC] = None
    # data type: PrepareAFungibleTokenTransferFromAddressRIBSBSC
    oneof_schema_3_validator: Optional[PrepareAFungibleTokenTransferFromAddressRIBSBSC] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(PREPAREAFUNGIBLETOKENTRANSFERFROMADDRESSRIBS_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PrepareAFungibleTokenTransferFromAddressRIBS.construct()
        error_messages = []
        match = 0
        # validate data type: PrepareAFungibleTokenTransferFromAddressRIBSE
        if not isinstance(v, PrepareAFungibleTokenTransferFromAddressRIBSE):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PrepareAFungibleTokenTransferFromAddressRIBSE`")
        else:
            match += 1
        # validate data type: PrepareAFungibleTokenTransferFromAddressRIBSEC
        if not isinstance(v, PrepareAFungibleTokenTransferFromAddressRIBSEC):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PrepareAFungibleTokenTransferFromAddressRIBSEC`")
        else:
            match += 1
        # validate data type: PrepareAFungibleTokenTransferFromAddressRIBSBSC
        if not isinstance(v, PrepareAFungibleTokenTransferFromAddressRIBSBSC):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PrepareAFungibleTokenTransferFromAddressRIBSBSC`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PrepareAFungibleTokenTransferFromAddressRIBS with oneOf schemas: PrepareAFungibleTokenTransferFromAddressRIBSBSC, PrepareAFungibleTokenTransferFromAddressRIBSE, PrepareAFungibleTokenTransferFromAddressRIBSEC. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PrepareAFungibleTokenTransferFromAddressRIBS with oneOf schemas: PrepareAFungibleTokenTransferFromAddressRIBSBSC, PrepareAFungibleTokenTransferFromAddressRIBSE, PrepareAFungibleTokenTransferFromAddressRIBSEC. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> PrepareAFungibleTokenTransferFromAddressRIBS:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> PrepareAFungibleTokenTransferFromAddressRIBS:
        """Returns the object represented by the json string"""
        instance = PrepareAFungibleTokenTransferFromAddressRIBS.construct()
        error_messages = []
        match = 0

        # deserialize data into PrepareAFungibleTokenTransferFromAddressRIBSE
        try:
            instance.actual_instance = PrepareAFungibleTokenTransferFromAddressRIBSE.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PrepareAFungibleTokenTransferFromAddressRIBSEC
        try:
            instance.actual_instance = PrepareAFungibleTokenTransferFromAddressRIBSEC.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PrepareAFungibleTokenTransferFromAddressRIBSBSC
        try:
            instance.actual_instance = PrepareAFungibleTokenTransferFromAddressRIBSBSC.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PrepareAFungibleTokenTransferFromAddressRIBS with oneOf schemas: PrepareAFungibleTokenTransferFromAddressRIBSBSC, PrepareAFungibleTokenTransferFromAddressRIBSE, PrepareAFungibleTokenTransferFromAddressRIBSEC. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PrepareAFungibleTokenTransferFromAddressRIBS with oneOf schemas: PrepareAFungibleTokenTransferFromAddressRIBSBSC, PrepareAFungibleTokenTransferFromAddressRIBSE, PrepareAFungibleTokenTransferFromAddressRIBSEC. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

