# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictBool, StrictStr

class ValidateAddressRI(BaseModel):
    """
    ValidateAddressRI
    """
    address: StrictStr = Field(..., description="Represents the specific address that will be checked if it's valid or not.")
    is_valid: StrictBool = Field(..., alias="isValid", description="Defines whether the address is valid or not. Set as boolean.")
    __properties = ["address", "isValid"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ValidateAddressRI:
        """Create an instance of ValidateAddressRI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ValidateAddressRI:
        """Create an instance of ValidateAddressRI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ValidateAddressRI.parse_obj(obj)

        _obj = ValidateAddressRI.parse_obj({
            "address": obj.get("address"),
            "is_valid": obj.get("isValid")
        })
        return _obj

