# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.decode_raw_transaction_hex_risb2 import DecodeRawTransactionHexRISB2  # noqa: E501
from cryptoapis.rest import ApiException

class TestDecodeRawTransactionHexRISB2(unittest.TestCase):
    """DecodeRawTransactionHexRISB2 unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test DecodeRawTransactionHexRISB2
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `DecodeRawTransactionHexRISB2`
        """
        model = cryptoapis.models.decode_raw_transaction_hex_risb2.DecodeRawTransactionHexRISB2()  # noqa: E501
        if include_optional :
            return DecodeRawTransactionHexRISB2(
                locktime = 1781965, 
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2', 
                v_size = 141, 
                version = 1, 
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risb2_vin_inner.DecodeRawTransactionHexRISB2_vin_inner(
                        address = 'bitcoincash:qq0adqyntn2zl9tsyjfagnyda9j2gfjkk574lxyrxd', 
                        input_hash = '073c565b56e98cfd53013136e92b9fdcf774409f9dc0daff2cf7afadde3a3f0c', 
                        output_index = '2', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risb_vin_inner_script_sig.DecodeRawTransactionHexRISB_vin_inner_scriptSig(
                            asm = '0014daaf6d5cb86befe42df851a4d1df052e663754c1', 
                            hex = '160014daaf6d5cb86befe42df851a4d1df052e663754c1', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], )
                    ], 
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risb2_vout_inner.DecodeRawTransactionHexRISB2_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risb2_vout_inner_script_pub_key.DecodeRawTransactionHexRISB2_vout_inner_scriptPubKey(
                            address = '2MzakdGTEp8SMWEHKwKM4HYv6uNCBXtHpkV', 
                            asm = 'OP_HASH160 507a5bd8cac1d9efdf4c0a4bfacb3e0abb4f8d15 OP_EQUAL', 
                            hex = 'a914507a5bd8cac1d9efdf4c0a4bfacb3e0abb4f8d1587', 
                            type = 'scripthash', ), 
                        value = '0.00014400', )
                    ], 
                weight = 256
            )
        else :
            return DecodeRawTransactionHexRISB2(
                locktime = 1781965,
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2',
                v_size = 141,
                version = 1,
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risb2_vin_inner.DecodeRawTransactionHexRISB2_vin_inner(
                        address = 'bitcoincash:qq0adqyntn2zl9tsyjfagnyda9j2gfjkk574lxyrxd', 
                        input_hash = '073c565b56e98cfd53013136e92b9fdcf774409f9dc0daff2cf7afadde3a3f0c', 
                        output_index = '2', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risb_vin_inner_script_sig.DecodeRawTransactionHexRISB_vin_inner_scriptSig(
                            asm = '0014daaf6d5cb86befe42df851a4d1df052e663754c1', 
                            hex = '160014daaf6d5cb86befe42df851a4d1df052e663754c1', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], )
                    ],
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risb2_vout_inner.DecodeRawTransactionHexRISB2_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risb2_vout_inner_script_pub_key.DecodeRawTransactionHexRISB2_vout_inner_scriptPubKey(
                            address = '2MzakdGTEp8SMWEHKwKM4HYv6uNCBXtHpkV', 
                            asm = 'OP_HASH160 507a5bd8cac1d9efdf4c0a4bfacb3e0abb4f8d15 OP_EQUAL', 
                            hex = 'a914507a5bd8cac1d9efdf4c0a4bfacb3e0abb4f8d1587', 
                            type = 'scripthash', ), 
                        value = '0.00014400', )
                    ],
        )
        """

    def testDecodeRawTransactionHexRISB2(self):
        """Test DecodeRawTransactionHexRISB2"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
