# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.decode_raw_transaction_hex_risd import DecodeRawTransactionHexRISD  # noqa: E501
from cryptoapis.rest import ApiException

class TestDecodeRawTransactionHexRISD(unittest.TestCase):
    """DecodeRawTransactionHexRISD unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test DecodeRawTransactionHexRISD
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `DecodeRawTransactionHexRISD`
        """
        model = cryptoapis.models.decode_raw_transaction_hex_risd.DecodeRawTransactionHexRISD()  # noqa: E501
        if include_optional :
            return DecodeRawTransactionHexRISD(
                locktime = 0, 
                transaction_hash = '1b2a8bd59c0d776015cfe6fd6b5b4f936ffcf8adf7a56a1eed460e915ce82ea7', 
                v_size = 141, 
                version = 1, 
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risd_vin_inner.DecodeRawTransactionHexRISD_vin_inner(
                        address = '7W7gfYstwDR6a2ZCxEidAuvshyomqJ8yXT', 
                        input_hash = '5061c34b1c1f40a9328c168f1070915bb9c450dbf2ecd566ae2e34e80651ecb4', 
                        output_index = '1', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risd_vin_inner_script_sig.DecodeRawTransactionHexRISD_vin_inner_scriptSig(
                            asm = 'OP_DUP OP_HASH160 1fd680935cd42f95702493d44c8de964a42656b5 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '4197968cb34bfba488b4a2399f7959b823fefad79ca0b5ed3f3a4bec4c0286cab55b896b28bbbcd4e61cf584cecfd47063b18b481d8d680eafbf869ada1a02c52441210237a84e6d70e775f274e4cbd9f30f9f8b1a426e8b08a9f802a851ce501c930011', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], )
                    ], 
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risd_vout_inner.DecodeRawTransactionHexRISD_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risd_vout_inner_script_pub_key.DecodeRawTransactionHexRISD_vout_inner_scriptPubKey(
                            address = 'yP8A3cbdxRtLRduy5mXDsBnJtMzHWs6ZXr', 
                            asm = 'OP_DUP OP_HASH160 4112d3f2cc01db043c0e638bb6338c83a7b9aa8f OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9144112d3f2cc01db043c0e638bb6338c83a7b9aa8f88ac', 
                            type = '76a9144112d3f2cc01db043c0e638bb6338c83a7b9aa8f88ac', ), 
                        value = '0.5896', )
                    ], 
                weight = 256
            )
        else :
            return DecodeRawTransactionHexRISD(
                locktime = 0,
                transaction_hash = '1b2a8bd59c0d776015cfe6fd6b5b4f936ffcf8adf7a56a1eed460e915ce82ea7',
                v_size = 141,
                version = 1,
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risd_vin_inner.DecodeRawTransactionHexRISD_vin_inner(
                        address = '7W7gfYstwDR6a2ZCxEidAuvshyomqJ8yXT', 
                        input_hash = '5061c34b1c1f40a9328c168f1070915bb9c450dbf2ecd566ae2e34e80651ecb4', 
                        output_index = '1', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risd_vin_inner_script_sig.DecodeRawTransactionHexRISD_vin_inner_scriptSig(
                            asm = 'OP_DUP OP_HASH160 1fd680935cd42f95702493d44c8de964a42656b5 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '4197968cb34bfba488b4a2399f7959b823fefad79ca0b5ed3f3a4bec4c0286cab55b896b28bbbcd4e61cf584cecfd47063b18b481d8d680eafbf869ada1a02c52441210237a84e6d70e775f274e4cbd9f30f9f8b1a426e8b08a9f802a851ce501c930011', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], )
                    ],
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risd_vout_inner.DecodeRawTransactionHexRISD_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risd_vout_inner_script_pub_key.DecodeRawTransactionHexRISD_vout_inner_scriptPubKey(
                            address = 'yP8A3cbdxRtLRduy5mXDsBnJtMzHWs6ZXr', 
                            asm = 'OP_DUP OP_HASH160 4112d3f2cc01db043c0e638bb6338c83a7b9aa8f OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9144112d3f2cc01db043c0e638bb6338c83a7b9aa8f88ac', 
                            type = '76a9144112d3f2cc01db043c0e638bb6338c83a7b9aa8f88ac', ), 
                        value = '0.5896', )
                    ],
        )
        """

    def testDecodeRawTransactionHexRISD(self):
        """Test DecodeRawTransactionHexRISD"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
