# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.decode_raw_transaction_hex_risd2 import DecodeRawTransactionHexRISD2  # noqa: E501
from cryptoapis.rest import ApiException

class TestDecodeRawTransactionHexRISD2(unittest.TestCase):
    """DecodeRawTransactionHexRISD2 unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test DecodeRawTransactionHexRISD2
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `DecodeRawTransactionHexRISD2`
        """
        model = cryptoapis.models.decode_raw_transaction_hex_risd2.DecodeRawTransactionHexRISD2()  # noqa: E501
        if include_optional :
            return DecodeRawTransactionHexRISD2(
                locktime = 0, 
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2', 
                v_size = 141, 
                version = 1, 
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risd2_vin_inner.DecodeRawTransactionHexRISD2_vin_inner(
                        address = 'DPzdWPsKaGvRn3AH7WjBpnNVHhAPELDY4o', 
                        input_hash = '746b56225c5eee8c50c0bedd885d18d3fda37b846d59eb7434b5e365e73e4b60', 
                        output_index = '2', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risd2_vin_inner_script_sig.DecodeRawTransactionHexRISD2_vin_inner_scriptSig(
                            asm = '030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206', 
                            hex = '21030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206ac', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            'qpq395ljesqakppupe3chd3n3jp60wd23ue00g66xx'
                            ], )
                    ], 
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risd2_vout_inner.DecodeRawTransactionHexRISD2_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risd2_vout_inner_script_pub_key.DecodeRawTransactionHexRISD2_vout_inner_scriptPubKey(
                            address = 'yd5KMREs3GLMe6mTJYr3YrH1juwNwrFCfB', 
                            asm = 'OP_DUP OP_HASH160 430158211605af1f0fa26d90405199621bdae5cd OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a914430158211605af1f0fa26d90405199621bdae5cd88ac', 
                            type = 'scripthash', ), 
                        value = '11.25', )
                    ], 
                weight = 154
            )
        else :
            return DecodeRawTransactionHexRISD2(
                locktime = 0,
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2',
                v_size = 141,
                version = 1,
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risd2_vin_inner.DecodeRawTransactionHexRISD2_vin_inner(
                        address = 'DPzdWPsKaGvRn3AH7WjBpnNVHhAPELDY4o', 
                        input_hash = '746b56225c5eee8c50c0bedd885d18d3fda37b846d59eb7434b5e365e73e4b60', 
                        output_index = '2', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risd2_vin_inner_script_sig.DecodeRawTransactionHexRISD2_vin_inner_scriptSig(
                            asm = '030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206', 
                            hex = '21030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206ac', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txinwitness = [
                            'qpq395ljesqakppupe3chd3n3jp60wd23ue00g66xx'
                            ], )
                    ],
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risd2_vout_inner.DecodeRawTransactionHexRISD2_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risd2_vout_inner_script_pub_key.DecodeRawTransactionHexRISD2_vout_inner_scriptPubKey(
                            address = 'yd5KMREs3GLMe6mTJYr3YrH1juwNwrFCfB', 
                            asm = 'OP_DUP OP_HASH160 430158211605af1f0fa26d90405199621bdae5cd OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a914430158211605af1f0fa26d90405199621bdae5cd88ac', 
                            type = 'scripthash', ), 
                        value = '11.25', )
                    ],
        )
        """

    def testDecodeRawTransactionHexRISD2(self):
        """Test DecodeRawTransactionHexRISD2"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
