# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.decode_raw_transaction_hex_risl import DecodeRawTransactionHexRISL  # noqa: E501
from cryptoapis.rest import ApiException

class TestDecodeRawTransactionHexRISL(unittest.TestCase):
    """DecodeRawTransactionHexRISL unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test DecodeRawTransactionHexRISL
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `DecodeRawTransactionHexRISL`
        """
        model = cryptoapis.models.decode_raw_transaction_hex_risl.DecodeRawTransactionHexRISL()  # noqa: E501
        if include_optional :
            return DecodeRawTransactionHexRISL(
                locktime = 2, 
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2', 
                v_size = 141, 
                version = 1, 
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risl_vin_inner.DecodeRawTransactionHexRISL_vin_inner(
                        address = 'LZ891CJWn54CpE6yJ4T3mzP8Xxwrg9gDpH', 
                        input_hash = '4c76c153f5de975f94da7526c1b4b4a13380ef93c946f6bed1892f4410600a3d', 
                        output_index = '3', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risl_vin_inner_script_sig.DecodeRawTransactionHexRISL_vin_inner_scriptSig(
                            asm = '3045022100f031442894c0fd60c195fbdb29c0bf72f143a815689b8840cd31ec31cc6a7721022028f74f0869e4666761c9ba1035cc714528a17de873dfc7b3a541d29f3942a2d8', 
                            hex = '483045022100f031442894c0fd60c195fbdb29c0bf72f143a815689b8840cd31ec31cc6a7721022028f74f0869e4666761c9ba1035cc714528a17de873dfc7b3a541d29f3942a2d80121028c533b6c0ce0ad714a8af36b64d207c4f61cd6d5af210362447c92b4105a4fab', 
                            type = 'scripthash', ), 
                        sequence = '4294967294', 
                        txinwitness = [
                            '304402204e88dfe79e58b640908812c496ea74d2941c23e70ee3d93ebd469dbd136afe0c02203d7631427c0b5cb96e8a8b23b6c8c0c8112ecb5fb020ee2a7a70841564ed679b01'
                            ], )
                    ], 
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risl_vout_inner.DecodeRawTransactionHexRISL_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risl_vout_inner_script_pub_key.DecodeRawTransactionHexRISL_vout_inner_scriptPubKey(
                            address = '3LAAY4fp88RsNHkVW5DZJgqUdbMD5rVoqZ', 
                            asm = 'OP_HASH160 ca94af32587de4e5006685ffffc65a818ccd3fbc OP_EQUAL', 
                            hex = 'a914ca94af32587de4e5006685ffffc65a818ccd3fbc87', 
                            type = 'scripthash', ), 
                        value = '0.03505975', )
                    ], 
                weight = 245
            )
        else :
            return DecodeRawTransactionHexRISL(
                locktime = 2,
                transaction_hash = '1ec73b0f61359927d02376b35993b756b1097cb9a857bec23da4c98c4977d2b2',
                v_size = 141,
                version = 1,
                vin = [
                    cryptoapis.models.decode_raw_transaction_hex_risl_vin_inner.DecodeRawTransactionHexRISL_vin_inner(
                        address = 'LZ891CJWn54CpE6yJ4T3mzP8Xxwrg9gDpH', 
                        input_hash = '4c76c153f5de975f94da7526c1b4b4a13380ef93c946f6bed1892f4410600a3d', 
                        output_index = '3', 
                        script_sig = cryptoapis.models.decode_raw_transaction_hex_risl_vin_inner_script_sig.DecodeRawTransactionHexRISL_vin_inner_scriptSig(
                            asm = '3045022100f031442894c0fd60c195fbdb29c0bf72f143a815689b8840cd31ec31cc6a7721022028f74f0869e4666761c9ba1035cc714528a17de873dfc7b3a541d29f3942a2d8', 
                            hex = '483045022100f031442894c0fd60c195fbdb29c0bf72f143a815689b8840cd31ec31cc6a7721022028f74f0869e4666761c9ba1035cc714528a17de873dfc7b3a541d29f3942a2d80121028c533b6c0ce0ad714a8af36b64d207c4f61cd6d5af210362447c92b4105a4fab', 
                            type = 'scripthash', ), 
                        sequence = '4294967294', 
                        txinwitness = [
                            '304402204e88dfe79e58b640908812c496ea74d2941c23e70ee3d93ebd469dbd136afe0c02203d7631427c0b5cb96e8a8b23b6c8c0c8112ecb5fb020ee2a7a70841564ed679b01'
                            ], )
                    ],
                vout = [
                    cryptoapis.models.decode_raw_transaction_hex_risl_vout_inner.DecodeRawTransactionHexRISL_vout_inner(
                        script_pub_key = cryptoapis.models.decode_raw_transaction_hex_risl_vout_inner_script_pub_key.DecodeRawTransactionHexRISL_vout_inner_scriptPubKey(
                            address = '3LAAY4fp88RsNHkVW5DZJgqUdbMD5rVoqZ', 
                            asm = 'OP_HASH160 ca94af32587de4e5006685ffffc65a818ccd3fbc OP_EQUAL', 
                            hex = 'a914ca94af32587de4e5006685ffffc65a818ccd3fbc87', 
                            type = 'scripthash', ), 
                        value = '0.03505975', )
                    ],
        )
        """

    def testDecodeRawTransactionHexRISL(self):
        """Test DecodeRawTransactionHexRISL"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
