# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.list_transactions_by_block_hash_ribsd import ListTransactionsByBlockHashRIBSD  # noqa: E501
from cryptoapis.rest import ApiException

class TestListTransactionsByBlockHashRIBSD(unittest.TestCase):
    """ListTransactionsByBlockHashRIBSD unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test ListTransactionsByBlockHashRIBSD
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `ListTransactionsByBlockHashRIBSD`
        """
        model = cryptoapis.models.list_transactions_by_block_hash_ribsd.ListTransactionsByBlockHashRIBSD()  # noqa: E501
        if include_optional :
            return ListTransactionsByBlockHashRIBSD(
                locktime = 1, 
                size = 266, 
                version = 1, 
                vin = [
                    cryptoapis.models.list_transactions_by_block_hash_ribsd_vin_inner.ListTransactionsByBlockHashRIBSD_vin_inner(
                        addresses = [
                            'DPzdWPsKaGvRn3AH7WjBpnNVHhAPELDY4o'
                            ], 
                        coinbase = '037a3a2f', 
                        script_sig = cryptoapis.models.get_transaction_details_by_transaction_idribsd_vin_inner_script_sig.GetTransactionDetailsByTransactionIDRIBSD_vin_inner_scriptSig(
                            asm = '030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206 OP_CHECKSIG', 
                            hex = '21030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206ac', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txid = '', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], 
                        value = '0.0225', 
                        vout = 2, )
                    ], 
                vout = [
                    cryptoapis.models.list_transactions_by_block_hash_ribsd_vout_inner.ListTransactionsByBlockHashRIBSD_vout_inner(
                        is_spent = False, 
                        script_pub_key = cryptoapis.models.list_transactions_by_block_hash_ribsd_vout_inner_script_pub_key.ListTransactionsByBlockHashRIBSD_vout_inner_scriptPubKey(
                            addresses = [
                                'yd5KMREs3GLMe6mTJYr3YrH1juwNwrFCfB'
                                ], 
                            asm = 'OP_DUP OP_HASH160 430158211605af1f0fa26d90405199621bdae5cd OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a914430158211605af1f0fa26d90405199621bdae5cd88ac', 
                            req_sigs = 2, 
                            type = 'scripthash', ), 
                        value = '11.25', )
                    ]
            )
        else :
            return ListTransactionsByBlockHashRIBSD(
                locktime = 1,
                size = 266,
                version = 1,
                vin = [
                    cryptoapis.models.list_transactions_by_block_hash_ribsd_vin_inner.ListTransactionsByBlockHashRIBSD_vin_inner(
                        addresses = [
                            'DPzdWPsKaGvRn3AH7WjBpnNVHhAPELDY4o'
                            ], 
                        coinbase = '037a3a2f', 
                        script_sig = cryptoapis.models.get_transaction_details_by_transaction_idribsd_vin_inner_script_sig.GetTransactionDetailsByTransactionIDRIBSD_vin_inner_scriptSig(
                            asm = '030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206 OP_CHECKSIG', 
                            hex = '21030483ff6271580681f4f7828c01df56d5aebfe982cbaa2922594be9eb6cf40206ac', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txid = '', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], 
                        value = '0.0225', 
                        vout = 2, )
                    ],
                vout = [
                    cryptoapis.models.list_transactions_by_block_hash_ribsd_vout_inner.ListTransactionsByBlockHashRIBSD_vout_inner(
                        is_spent = False, 
                        script_pub_key = cryptoapis.models.list_transactions_by_block_hash_ribsd_vout_inner_script_pub_key.ListTransactionsByBlockHashRIBSD_vout_inner_scriptPubKey(
                            addresses = [
                                'yd5KMREs3GLMe6mTJYr3YrH1juwNwrFCfB'
                                ], 
                            asm = 'OP_DUP OP_HASH160 430158211605af1f0fa26d90405199621bdae5cd OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a914430158211605af1f0fa26d90405199621bdae5cd88ac', 
                            req_sigs = 2, 
                            type = 'scripthash', ), 
                        value = '11.25', )
                    ],
        )
        """

    def testListTransactionsByBlockHashRIBSD(self):
        """Test ListTransactionsByBlockHashRIBSD"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
