# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.list_transactions_by_block_height_ribsd import ListTransactionsByBlockHeightRIBSD  # noqa: E501
from cryptoapis.rest import ApiException

class TestListTransactionsByBlockHeightRIBSD(unittest.TestCase):
    """ListTransactionsByBlockHeightRIBSD unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test ListTransactionsByBlockHeightRIBSD
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `ListTransactionsByBlockHeightRIBSD`
        """
        model = cryptoapis.models.list_transactions_by_block_height_ribsd.ListTransactionsByBlockHeightRIBSD()  # noqa: E501
        if include_optional :
            return ListTransactionsByBlockHeightRIBSD(
                locktime = 0, 
                size = 125, 
                version = 1, 
                vin = [
                    cryptoapis.models.list_transactions_by_block_height_ribsd_vin_inner.ListTransactionsByBlockHeightRIBSD_vin_inner(
                        addresses = [
                            'XjDToy8mMhuGuQcFumCJ5zn3poSk1E1CU5'
                            ], 
                        coinbase = '03ab421c182f5669614254432f4d696e6564206279207573737475362f10cc5bc9003c83520c01a2fb4ed10d0000', 
                        script_sig = cryptoapis.models.list_transactions_by_block_height_ribsd_vin_inner_script_sig.ListTransactionsByBlockHeightRIBSD_vin_inner_scriptSig(
                            asm = 'OP_DUP OP_HASH160 1fd680935cd42f95702493d44c8de964a42656b5 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '47304402203b66940c39093423fd72996b7c0b7d0f794e8bf92a2c71936683a317dc9e6943022006ff6c7545c30ac1ad05e6cd5fa96180a6d41ba4c9e57f5b9f2b9a80104bc7e8812102bfda4ad00f98e3f3896a535424bdfec0f8f7ac555d29dfd9593193402c676fc2', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txid = '1e7d7e6a5fd5a03aca934ee350f54406421610d3ea16fd97b2a950cdc0616014', 
                        txinwitness = [
                            'yP8A3cbdxRtLRduy5mXDsBnJtMzHWs6ZXr'
                            ], 
                        value = '10.0001', 
                        vout = 2, )
                    ], 
                vout = [
                    cryptoapis.models.list_transactions_by_block_height_ribsd_vout_inner.ListTransactionsByBlockHeightRIBSD_vout_inner(
                        is_spent = False, 
                        script_pub_key = cryptoapis.models.list_transactions_by_block_height_ribsd_vout_inner_script_pub_key.ListTransactionsByBlockHeightRIBSD_vout_inner_scriptPubKey(
                            addresses = [
                                'XbF2w4FtN49aw6gBqkDzMXMrGaKqhb71xJ'
                                ], 
                            asm = 'OP_DUP OP_HASH160 0616939ebfda6d544a6fa707a306af75066d4c3e OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9140616939ebfda6d544a6fa707a306af75066d4c3e88ac', 
                            req_sigs = 2, 
                            type = 'scripthash', ), 
                        value = '1.06482395', )
                    ]
            )
        else :
            return ListTransactionsByBlockHeightRIBSD(
                locktime = 0,
                size = 125,
                version = 1,
                vin = [
                    cryptoapis.models.list_transactions_by_block_height_ribsd_vin_inner.ListTransactionsByBlockHeightRIBSD_vin_inner(
                        addresses = [
                            'XjDToy8mMhuGuQcFumCJ5zn3poSk1E1CU5'
                            ], 
                        coinbase = '03ab421c182f5669614254432f4d696e6564206279207573737475362f10cc5bc9003c83520c01a2fb4ed10d0000', 
                        script_sig = cryptoapis.models.list_transactions_by_block_height_ribsd_vin_inner_script_sig.ListTransactionsByBlockHeightRIBSD_vin_inner_scriptSig(
                            asm = 'OP_DUP OP_HASH160 1fd680935cd42f95702493d44c8de964a42656b5 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '47304402203b66940c39093423fd72996b7c0b7d0f794e8bf92a2c71936683a317dc9e6943022006ff6c7545c30ac1ad05e6cd5fa96180a6d41ba4c9e57f5b9f2b9a80104bc7e8812102bfda4ad00f98e3f3896a535424bdfec0f8f7ac555d29dfd9593193402c676fc2', 
                            type = 'scripthash', ), 
                        sequence = '4294967295', 
                        txid = '1e7d7e6a5fd5a03aca934ee350f54406421610d3ea16fd97b2a950cdc0616014', 
                        txinwitness = [
                            'yP8A3cbdxRtLRduy5mXDsBnJtMzHWs6ZXr'
                            ], 
                        value = '10.0001', 
                        vout = 2, )
                    ],
                vout = [
                    cryptoapis.models.list_transactions_by_block_height_ribsd_vout_inner.ListTransactionsByBlockHeightRIBSD_vout_inner(
                        is_spent = False, 
                        script_pub_key = cryptoapis.models.list_transactions_by_block_height_ribsd_vout_inner_script_pub_key.ListTransactionsByBlockHeightRIBSD_vout_inner_scriptPubKey(
                            addresses = [
                                'XbF2w4FtN49aw6gBqkDzMXMrGaKqhb71xJ'
                                ], 
                            asm = 'OP_DUP OP_HASH160 0616939ebfda6d544a6fa707a306af75066d4c3e OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9140616939ebfda6d544a6fa707a306af75066d4c3e88ac', 
                            req_sigs = 2, 
                            type = 'scripthash', ), 
                        value = '1.06482395', )
                    ],
        )
        """

    def testListTransactionsByBlockHeightRIBSD(self):
        """Test ListTransactionsByBlockHeightRIBSD"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
