# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb import ListUnconfirmedTransactionsByAddressRIBSB  # noqa: E501
from cryptoapis.rest import ApiException

class TestListUnconfirmedTransactionsByAddressRIBSB(unittest.TestCase):
    """ListUnconfirmedTransactionsByAddressRIBSB unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test ListUnconfirmedTransactionsByAddressRIBSB
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `ListUnconfirmedTransactionsByAddressRIBSB`
        """
        model = cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb.ListUnconfirmedTransactionsByAddressRIBSB()  # noqa: E501
        if include_optional :
            return ListUnconfirmedTransactionsByAddressRIBSB(
                locktime = 1781965, 
                size = 222, 
                v_size = 222, 
                version = 1, 
                vin = [
                    cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vin_inner.ListUnconfirmedTransactionsByAddressRIBSB_vin_inner(
                        addresses = [
                            'n1eypQAVqQMmDuXffCF3LPXREmF71ecuai'
                            ], 
                        script_sig = cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vin_inner_script_sig.ListUnconfirmedTransactionsByAddressRIBSB_vin_inner_scriptSig(
                            asm = '304402203862a918653adb03c5dcd82965b2e6c658b5cabdecba315231975873c5a12aa102203101f4d9b4b1cae943c04054b53d2dc8a359776963e9d029fdf0ddba785ab71f[ALL] 027970a92cad2023bc5e83dc4199333a5c6f45a15a141963ac61a3c773940b0115', 
                            hex = '47304402203862a918653adb03c5dcd82965b2e6c658b5cabdecba315231975873c5a12aa102203101f4d9b4b1cae943c04054b53d2dc8a359776963e9d029fdf0ddba785ab71f0121027970a92cad2023bc5e83dc4199333a5c6f45a15a141963ac61a3c773940b0115', 
                            type = 'pubkeyhash', ), 
                        sequence = '4294967295', 
                        txid = 'aca730af131622fa0d765706e9e5263faee054b03a00b6e9b25f235462fb3043', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], 
                        value = '0.19163773', 
                        vout = 1, )
                    ], 
                vout = [
                    cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vout_inner.ListUnconfirmedTransactionsByAddressRIBSB_vout_inner(
                        is_spent = True, 
                        script_pub_key = cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vout_inner_script_pub_key.ListUnconfirmedTransactionsByAddressRIBSB_vout_inner_scriptPubKey(
                            addresses = [
                                'tb1qdc0jaryry3u56j94xp5zeyhn9zjuzkqec2mvfh'
                                ], 
                            asm = 'OP_DUP OP_HASH160 3502000e8ff5717295df19fbae4597c4f43fb1d9 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9143502000e8ff5717295df19fbae4597c4f43fb1d988ac', 
                            req_sigs = 1, 
                            type = 'witness_v0_keyhash', ), 
                        value = '0.09720621', )
                    ]
            )
        else :
            return ListUnconfirmedTransactionsByAddressRIBSB(
                locktime = 1781965,
                size = 222,
                v_size = 222,
                version = 1,
                vin = [
                    cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vin_inner.ListUnconfirmedTransactionsByAddressRIBSB_vin_inner(
                        addresses = [
                            'n1eypQAVqQMmDuXffCF3LPXREmF71ecuai'
                            ], 
                        script_sig = cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vin_inner_script_sig.ListUnconfirmedTransactionsByAddressRIBSB_vin_inner_scriptSig(
                            asm = '304402203862a918653adb03c5dcd82965b2e6c658b5cabdecba315231975873c5a12aa102203101f4d9b4b1cae943c04054b53d2dc8a359776963e9d029fdf0ddba785ab71f[ALL] 027970a92cad2023bc5e83dc4199333a5c6f45a15a141963ac61a3c773940b0115', 
                            hex = '47304402203862a918653adb03c5dcd82965b2e6c658b5cabdecba315231975873c5a12aa102203101f4d9b4b1cae943c04054b53d2dc8a359776963e9d029fdf0ddba785ab71f0121027970a92cad2023bc5e83dc4199333a5c6f45a15a141963ac61a3c773940b0115', 
                            type = 'pubkeyhash', ), 
                        sequence = '4294967295', 
                        txid = 'aca730af131622fa0d765706e9e5263faee054b03a00b6e9b25f235462fb3043', 
                        txinwitness = [
                            '3045022100c11ea5740bcd69f0f68a4914279838014d28923134d18e05c5a5486dfd06cc8c02200dadccec3f07bed0d1040f9e5a155efa5fdd40fc91f92342578d26848da4c6b901'
                            ], 
                        value = '0.19163773', 
                        vout = 1, )
                    ],
                vout = [
                    cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vout_inner.ListUnconfirmedTransactionsByAddressRIBSB_vout_inner(
                        is_spent = True, 
                        script_pub_key = cryptoapis.models.list_unconfirmed_transactions_by_address_ribsb_vout_inner_script_pub_key.ListUnconfirmedTransactionsByAddressRIBSB_vout_inner_scriptPubKey(
                            addresses = [
                                'tb1qdc0jaryry3u56j94xp5zeyhn9zjuzkqec2mvfh'
                                ], 
                            asm = 'OP_DUP OP_HASH160 3502000e8ff5717295df19fbae4597c4f43fb1d9 OP_EQUALVERIFY OP_CHECKSIG', 
                            hex = '76a9143502000e8ff5717295df19fbae4597c4f43fb1d988ac', 
                            req_sigs = 1, 
                            type = 'witness_v0_keyhash', ), 
                        value = '0.09720621', )
                    ],
        )
        """

    def testListUnconfirmedTransactionsByAddressRIBSB(self):
        """Test ListUnconfirmedTransactionsByAddressRIBSB"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
