# coding: utf-8

"""
    CryptoAPIs

    Crypto APIs is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.  # noqa: E501

    The version of the OpenAPI document: 2021-03-20
    Contact: developers@cryptoapis.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest
import datetime

import cryptoapis
from cryptoapis.models.list_wallet_transactions_ri import ListWalletTransactionsRI  # noqa: E501
from cryptoapis.rest import ApiException

class TestListWalletTransactionsRI(unittest.TestCase):
    """ListWalletTransactionsRI unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test ListWalletTransactionsRI
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `ListWalletTransactionsRI`
        """
        model = cryptoapis.models.list_wallet_transactions_ri.ListWalletTransactionsRI()  # noqa: E501
        if include_optional :
            return ListWalletTransactionsRI(
                direction = 'incoming', 
                fee = cryptoapis.models.list_wallet_transactions_ri_fee.ListWalletTransactionsRI_fee(
                    amount = '0.00003', 
                    converted_amount = '1.50', 
                    exchange_rate_unit = 'USD', 
                    symbol = 'ETH', ), 
                fungible_tokens = [
                    cryptoapis.models.list_wallet_transactions_ri_fungible_tokens_inner.ListWalletTransactionsRI_fungibleTokens_inner(
                        amount = '0.254', 
                        converted_amount = '0.0034', 
                        exchange_rate_unit = 'USD', 
                        name = 'Tether USD', 
                        recipient = '0x229f7172eab232d09d2de05a3e3b7b79c9abfe3b', 
                        sender = '0x1b7aa44088a0ea95bdc65fef6e5071e946bf7d8f', 
                        symbol = 'ETH', 
                        token_decimals = 6, 
                        type = 'ERC-20', )
                    ], 
                internal_transactions = [
                    cryptoapis.models.list_wallet_transactions_ri_internal_transactions_inner.ListWalletTransactionsRI_internalTransactions_inner(
                        amount = '0.001', 
                        converted_amount = '4.30365936483792', 
                        exchange_rate_unit = 'USD', 
                        operation_id = 'call_0', 
                        recipient = '0x07344b7649c5ff096b0317957d9a208931d04d5e', 
                        sender = '0x4b8ec9e58a8b08f3803f84fb52d0a50e84444592', 
                        symbol = 'ETH', )
                    ], 
                non_fungible_tokens = [
                    cryptoapis.models.list_wallet_transactions_ri_non_fungible_tokens_inner.ListWalletTransactionsRI_nonFungibleTokens_inner(
                        converted_amount = '0.034', 
                        exchange_rate_unit = 'USD', 
                        name = 'Axie Infinity', 
                        recipient = '0xdac17f958d2ee523a2206206994597c13d831ec7', 
                        sender = '0x65b895f400dae5541d70cbbec07527210158f6e2', 
                        symbol = 'AXS', 
                        token_id = '13383', 
                        type = 'ERC-721', )
                    ], 
                recipients = [
                    cryptoapis.models.list_wallet_transactions_ri_recipients_inner.ListWalletTransactionsRI_recipients_inner(
                        address = '0x6f61e3c2fbb8c8be698bd0907ba6c04b62800fe5', 
                        amount = '0.00427167', 
                        label = 'yourStringHere', )
                    ], 
                senders = [
                    cryptoapis.models.list_wallet_transactions_ri_senders_inner.ListWalletTransactionsRI_senders_inner(
                        address = '0x6f61e3c2fbb8c8be698bd0907ba6c04b62800fe5', 
                        amount = '0.0001', 
                        label = 'yourStringHere', )
                    ], 
                status = 'confirmed', 
                timestamp = 1622466746, 
                transaction_id = 'b3ddf04d74e5bd57f3ccb5375db6f39d228ed98cfa1ae9bf959b9406fc975f01', 
                value = cryptoapis.models.list_wallet_transactions_ri_value.ListWalletTransactionsRI_value(
                    amount = '0.001', 
                    converted_amount = '150', 
                    exchange_rate_unit = 'USD', 
                    symbol = 'ETH', )
            )
        else :
            return ListWalletTransactionsRI(
                direction = 'incoming',
                fee = cryptoapis.models.list_wallet_transactions_ri_fee.ListWalletTransactionsRI_fee(
                    amount = '0.00003', 
                    converted_amount = '1.50', 
                    exchange_rate_unit = 'USD', 
                    symbol = 'ETH', ),
                recipients = [
                    cryptoapis.models.list_wallet_transactions_ri_recipients_inner.ListWalletTransactionsRI_recipients_inner(
                        address = '0x6f61e3c2fbb8c8be698bd0907ba6c04b62800fe5', 
                        amount = '0.00427167', 
                        label = 'yourStringHere', )
                    ],
                senders = [
                    cryptoapis.models.list_wallet_transactions_ri_senders_inner.ListWalletTransactionsRI_senders_inner(
                        address = '0x6f61e3c2fbb8c8be698bd0907ba6c04b62800fe5', 
                        amount = '0.0001', 
                        label = 'yourStringHere', )
                    ],
                status = 'confirmed',
                timestamp = 1622466746,
                transaction_id = 'b3ddf04d74e5bd57f3ccb5375db6f39d228ed98cfa1ae9bf959b9406fc975f01',
                value = cryptoapis.models.list_wallet_transactions_ri_value.ListWalletTransactionsRI_value(
                    amount = '0.001', 
                    converted_amount = '150', 
                    exchange_rate_unit = 'USD', 
                    symbol = 'ETH', ),
        )
        """

    def testListWalletTransactionsRI(self):
        """Test ListWalletTransactionsRI"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
